// Networked Systems (H) - Formative Exercise 3
// Worked Answer
//
// Copyright (c) 2012-2018 University of Glasgow
// All rights reserved.

#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>

#define BUFLEN 1500

int
main(int argc, const char *argv[])
{
  int                      i, wlen;
  int                      fd;
  char                    *buf = malloc(BUFLEN);
  struct addrinfo          hints, *ai;

  if (argc != 2) {
    printf("Usage: %s <hostname>\n", argv[0]);
    return 1;
  }

  // Look up the IP address of the hostname specified on the command line
  memset(&hints, 0, sizeof(hints));
  hints.ai_family    = PF_UNSPEC;
  hints.ai_socktype  = SOCK_DGRAM;
  if ((i = getaddrinfo(argv[1], "5008", &hints, &ai)) != 0) {
    printf("Unable to look up IP address: %s", gai_strerror(i));
    return 1;
  }

  // Create a TCP/IP socket
  fd = socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
  if (fd == -1) {
    perror("Unable to create socket");
    return 1;
  }

  // Send "Hello, world!"
  sprintf(buf, "Hello, world!");
  wlen = sendto(fd, buf, strlen(buf), 0, ai->ai_addr, ai->ai_addrlen);
  if (wlen == -1) {
    perror("Unable to send request");
    close(fd);
    return 1;
  }

  // Close the connection and exit
  freeaddrinfo(ai);
  close(fd);
  free(buf);

  return 0;
}

// vim: set ts=2 tw=0 ai et:
